%% 1.  Ordinary least square estimation
clear all; close all;clc
% Import data
Data1=load('logfile1.txt');
[nrow,ncol]=size(Data1);

Time=Data1(1:nrow,1);
ControlSig=Data1(1:nrow,2);
Speed=Data1(1:nrow,3);
% the LS-form: S=K*C-T*dS/dt+K*L
[nrow,ncol]=size(Data1);
S=Speed(1:nrow-100);
t=Time(1:nrow-100);
C=ControlSig(1:nrow-100);
dSdt=zeros(nrow-100,1);
ONE=ones(nrow-100,1);
for i=2:nrow-100;           % calculate dS/dt
    dS=S(i)-S(i-1);
    dt=t(i)-t(i-1);
    dSdt(i)=dS/dt;
  
end
% the matrix for LS estimation S= [C dSdt 1]*[K;-T;KL]
phi=[C dSdt ONE];
phiT=phi.';
Theta= inv(phiT*phi)*phiT*S; % Calculation of parameters
% The results
K=Theta(1);
T=-Theta(2);
L=Theta(3)/Theta(1);
disp('Least Sauare Estimation of K, T , and L')
K
T 
L
% Simulation, use the last 100 observations
S_test=Speed(nrow-99:nrow);
t_test=Time(nrow-99:nrow);
C_test=ControlSig(nrow-99:nrow);
dSdt_test=zeros(100,1);
ONE_test=ones(100,1);
for i=2:100;           % calculate dS/dt
    dS=S(i)-S(i-1);
    dt=t(i)-t(i-1);
    dSdt_test(i)=dS/dt;
  
end
phi_test=[C_test dSdt_test ONE_test];
S_hat=phi_test*Theta;
S_real=Speed(nrow-99:nrow);
Error=S_real-S_hat; % The error of estimation
%----------------------
% Plot
t_test=Time(nrow-99:nrow);
plot(t_test,S_hat,'r',t_test,S_real,'b');
title('DC motor Real Tout (blue) and simulated Tout(red)')
ylabel('Speed (krpm)');
xlabel('t [s]');
legend ('simulation','real')




