%% Exercise 5-2: grid optimization method
clear all, close all; clc
%% load data and creat known variables
Data2=load('airheater_logfile.txt');
[nrow,ncol]=size(Data2);
Time=Data2(1:nrow,1);
ControlSig=Data2(1:nrow,2);
Tout=Data2(1:nrow,3);
dToutdt=zeros(nrow,1); % obtain the erivative 
for i=2:nrow
    dTout=Tout(i)-Tout(i-1); % center difference method
    dt=Time(i)-Time(i-1);
    dToutdt(i)=dTout/dt;
    
end
dTheatdt=dToutdt; %dT_heatdt=dT_outdt
U=ControlSig;
t=Time;

%% Subset of variable for model fitting, leave the last 100 data out
U_f=ControlSig(1:nrow-100);
Tout_f=Tout(1:nrow-100);
dTheatdt_f=dTheatdt(1:nrow-100);
t_f=Time(1:nrow-100);

%% Initialization
disp ('Objective fuction f=(Tout - (Tenv+Kh*u*(t-theta_d)-theta_t*dTheatdt))^2')
Tenv_min=5;Tenv_max=35; N_Tenv=20;
Tenv_array=linspace(Tenv_min,Tenv_max, N_Tenv);
Tenv_0=20;

Kh_min=0;Kh_max=15; N_Kh=20;
Kh_array=linspace(Kh_min,Kh_max,N_Kh);
Kh_0=3.5;

theta_t_min=0; theta_t_max=45; N_theta_t=20;
theta_t_array=linspace(theta_t_min,theta_t_max,N_theta_t);
theta_t_0=23;

theta_d_min=0; theta_d_max=10; N_theta_d=20;
theta_d_array=linspace(theta_d_min,theta_d_max,N_theta_d);
theta_d_0=3;

f_min=inf;
Tenv_opt=Tenv_0;
Kh_opt=Kh_0;
theta_t_opt=theta_t_0;
theta_d_opt=theta_d_0;
tic;

%% Grit search
for k_Tenv=1:length(Tenv_array);
    Tenv=Tenv_array(k_Tenv);
    for k_Kh=1:length(Kh_array);
        
        Kh=Kh_array(k_Kh);
        for k_theta_t=1:length(theta_t_array);
            theta_t=theta_t_array(k_theta_t);
            for k_theta_d=1:length(theta_d_array);
                theta_d=theta_d_array(k_theta_d);
                for i=1:length(Tout_f);
                f=(Tout_f(i) - (Tenv+Kh*U_f(i)*(t_f(i)-theta_d)-theta_t*dTheatdt_f(i)))^2;
                if f<=f_min;
                    f_min=f;
                    Tenv_opt=Tenv;
                    Kh_opt=Kh;
                    theta_t_opt=theta_t;
                    theta_d_opt=theta_d;
                end
                
                end
                
            end
            
        end
               
    end
end
disp('Optimal Solution')
f_min
Tenv_opt
Kh_opt
theta_t_opt
theta_d_opt

% A simulation used the used 100 observations and the estimated parameters
Tout_hat = zeros (100,1);
Tout_real= Tout((nrow-99):nrow);
U_v=ControlSig((nrow-99):nrow);
Tout_v=Tout((nrow-99):nrow);
dTheatdt_v=dTheatdt((nrow-99):nrow);
t_v=Time((nrow-99):nrow);
Tenv=Tenv_opt;
Kh=Kh_opt;
theta_t=theta_t_opt;
theta_d=theta_d_opt;

for i=1:100;
    Tout_hat(i)=Tenv+Kh*U_v(i)*(t_v(i)-theta_d)-theta_t*dTheatdt_v(i); 
end
plot (t_v,Tout_hat,t_v,Tout_real);
xlabel ('Time, sec')
ylabel ('Output Temperature C');
legend ('Simulation','Real')

%----------------------------------------------------------
% Comparison for Exercise 5-4
Tout_grid=Tenv_opt+Kh_opt.*U.*(t-theta_d_opt)-theta_t_opt.*dTheatdt;
csvwrite('grid.csv',Tout_grid)


