%% Exercise 5-2: grit optimization method
clear all, close all; clc
%%-----------------------------------------------------
% load data and creat known variables
Data2=load('airheater_logfile.txt');
[nrow,ncol]=size(Data2);
% Extract data from datafile 
Time=Data2(1:nrow,1);
ControlSig=Data2(1:nrow,2);
Tout=Data2(1:nrow,3);
dToutdt=zeros(nrow,1); % retreave the derivative
for i=2:nrow-1;
    dTout=Tout(i+1)-Tout(i-1); % use center difference method for this time
    dt=Time(i+1)-Time(i-1);
    dToutdt(i)=dTout/dt;
    
end
dTheatdt=dToutdt;
%%------------------------------------------
disp ('-----------------------------------------')
disp ('Using nonlinear least squares method with fmincon() in Matlab')
disp ('Model Tout = Tenv+Kh*u*(t-theta_d)-theta_t*dTheatdt')
disp ('Variables: Tout, u, t, dTheatdt')
disp ('Constraints')
disp ('0<= Tenv <=35')
disp ('0<= Kh <=15')
disp ('0<= theta-t <=60')
disp ('0<= theta-t <=20')
%-----------------------------------------
% model Variables
Tout = Tout;
u=ControlSig;
t=Time;
dTheatdt=dToutdt; 
vars_model.Tout=Tout;
vars_model.u=u;
vars_model.t=t;
vars_model.dTheatdt=dTheatdt;
% initial values
Tenv_0=20;
Kh_0=3.5;
theta_t_0=23;
theta_d_0=3;
p_0=[Tenv_0, Kh_0, theta_t_0, theta_d_0]';
%--------------------------------
% model
Tout_sim= @(p) p(1)+p(2).*u.*(t-p(4))-(p(3).*dTheatdt);
obj = @(p) sum(((Tout_sim(p)-Tout)./Tout).^2);
% Constraints of model parameters
p_lb=[0,0,0,0]';
p_ub=[35,15,60,20]';

%fmincon
p_opt=fmincon(obj,p_0,[],[],[],[],p_lb,p_ub)

%-------------------------------------------------------
%for comparison Exercise5-4
Tout_fmincon=Tout_sim(p_opt);
csvwrite('fmincon.csv',Tout_fmincon)

% Plot
plot (t,Tout,'r',t,Tout_fmincon,'b')
legend ('real','simulation')
xlabel('time (sec)')
ylabel('Tout (C)')









