clear all; close all; clc
%------------------------------------------------
% load tada and extract input/output
Data2=load('airheater_logfile.txt');
[nrow,ncol]=size(Data2);
t_all=Data2(1:nrow,1);
u_all=Data2(1:nrow,2);
Tout_all=Data2(1:nrow,3);
%-----------------------------------------------
% slit the dataset for model fitting and model validation
Ts=0.02; % samping interval
F=0.5; % 50% used for model construction 
N=floor(F*nrow);
t_estim=Ts*[1:N]';
u_estim=u_all(1:N);
Tout_estim=Tout_all(1:N);
t_valid=Ts*[N+1:nrow]';
u_valid=u_all(N+1:nrow);
Tout_valid=Tout_all(N+1:nrow);
% ----------------------------------------
% model building
modelorder=1;
model_est=n4sid(iddata(Tout_estim,u_estim,Ts),modelorder);
disp ('The discrete-time state space model')
A=model_est.A
B=model_est.B
C=model_est.C
D=model_est.D
% ----------------------------------------------------------
% Modle validation. Firstly convert to z-transfer function
[num den]=th2tf(model_est);
H_disc=tf(num,den,Ts);
Tout_sim=lsim(H_disc,u_valid);
th2tf(model_est)

%-------------------------------------------------
% Plot
plot(t_valid,Tout_sim,'r',t_valid,Tout_valid,'b');
title('Simulated Tout(red)and Real Tout (blue)')
ylabel('Tout C');
xlabel('t [s]');
legend ('Simulated','Real')









